diff --git a/src/backend/replication/walreceiver.c b/src/backend/replication/walreceiver.c
index 17f1a49f87..32693c56db 100644
--- a/src/backend/replication/walreceiver.c
+++ b/src/backend/replication/walreceiver.c
@@ -758,6 +758,10 @@ WalRcvFetchTimeLineHistoryFiles(TimeLineID first, TimeLineID last)
 			 */
 			writeTimeLineHistoryFile(tli, content, len);
 
+			/* Mark history file as ready for archiving */
+			if (XLogArchiveMode == ARCHIVE_MODE_ALWAYS)
+				XLogArchiveNotify(fname);
+
 			pfree(fname);
 			pfree(content);
 		}
